Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/Makefile	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/Makefile	(revision 15)
@@ -8,8 +8,8 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= ../../..
+DIR_MORPHEO			= ../../../..
 
 #-----[ Library ]------------------------------------------
-LIBRARY				= $(DIR_LIB)/libRegisterFile.a
+LIBRARY				= $(DIR_LIB)/libRegisterFile_Monolithic.a
 
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/Makefile.deps	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/Makefile.deps	(revision 15)
@@ -15,11 +15,11 @@
 endif
 
-RegisterFile			= yes
+RegisterFile_Monolithic			= yes
 #-----[ Library ]------------------------------------------
-RegisterFile_LIBRARY		= 	-lRegisterFile		\
+RegisterFile_Monolithic_LIBRARY		= 	-lRegisterFile_Monolithic		\
 					$(Group_LIBRARY)	\
 					$(Behavioural_LIBRARY)	
 
-RegisterFile_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile/lib	\
+RegisterFile_Monolithic_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/lib	\
 					$(Group_DIR_LIBRARY)					\
 					$(Behavioural_DIR_LIBRARY)	
@@ -27,11 +27,11 @@
 #-----[ Rules ]--------------------------------------------
 
-RegisterFile_library		:
+RegisterFile_Monolithic_library		:
 				@$(MAKE)  Behavioural_library
 				@$(MAKE)  Group_library
-				@$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile --makefile=Makefile 
+				@$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic --makefile=Makefile 
 	
-RegisterFile_library_clean	:
+RegisterFile_Monolithic_library_clean	:
 				@$(MAKE)  Behavioural_library_clean
 				@$(MAKE)  Group_library_clean
-				@$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile --makefile=Makefile clean
+				@$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic --makefile=Makefile clean
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/Makefile	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/Makefile	(revision 15)
@@ -8,9 +8,9 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= ../../../..
+DIR_MORPHEO			= ../../../../..
 
-LIBRARY				= $(RegisterFile_LIBRARY)
+LIBRARY				= $(RegisterFile_Monolithic_LIBRARY)
 
-DIR_LIBRARY			= $(RegisterFile_DIR_LIBRARY)
+DIR_LIBRARY			= $(RegisterFile_Monolithic_DIR_LIBRARY)
 
 #-----[ include ]------------------------------------------
@@ -19,7 +19,7 @@
 				@$(MAKE) all_selftest
 
-library				: RegisterFile_library
+library				: RegisterFile_Monolithic_library
 
-library_clean			: RegisterFile_library_clean
+library_clean			: RegisterFile_Monolithic_library_clean
 
 include                         ../Makefile.deps
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/configuration.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/configuration.cfg	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/configuration.cfg	(revision 15)
@@ -1,3 +1,3 @@
-RegisterFile
+RegisterFile_Monolithic
 1	8 	*2	# nb_port_read
 1	4	*2	# nb_port_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/include/test.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/include/test.h	(revision 15)
@@ -4,5 +4,4 @@
  * [ Description ]
  * 
- * Test "RegisterFile"
  */
 
@@ -14,5 +13,5 @@
 #include <iostream>
 
-#include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
 
 using namespace std;
@@ -21,5 +20,6 @@
 using namespace morpheo::behavioural::generic;
 using namespace morpheo::behavioural::generic::registerfile;
+using namespace morpheo::behavioural::generic::registerfile::registerfile_monolithic;
 
 void test   (string name,
-	     morpheo::behavioural::generic::registerfile::Parameters param);
+	     morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters param);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/main.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/main.cpp	(revision 15)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Generic/RegisterFile/SelfTest/include/test.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/include/test.h"
 
 #define NB_PARAMS 4
@@ -36,6 +36,6 @@
   const uint32_t size_word     = atoi(argv[5]);
   
-  morpheo::behavioural::generic::registerfile::Parameters param (nb_port_read ,
-								 nb_port_write,
+  morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters param (nb_port_read ,
+											  nb_port_write,
 								 nb_word      ,
 								 size_word    );
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/test.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/test.cpp	(revision 15)
@@ -7,9 +7,9 @@
  */
 
-#include "Behavioural/Generic/RegisterFile/SelfTest/include/test.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/include/test.h"
 #include "Include/Test.h"
 
 void test (string name,
-	   morpheo::behavioural::generic::registerfile::Parameters param)
+	   morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters param)
 {
   cout << "<" << name << "> : Simulation SystemC" << endl;
@@ -31,9 +31,9 @@
     }
 
-  RegisterFile * registerfile = new RegisterFile (name.c_str(),
+  RegisterFile_Monolithic * registerfile = new RegisterFile_Monolithic (name.c_str(),
 #ifdef STATISTICS
-						  morpheo::behavioural::Parameters_Statistics(5,50),
+									morpheo::behavioural::Parameters_Statistics(5,50),
 #endif
-						  param);
+									param);
   
 #ifdef SYSTEMC
@@ -58,5 +58,5 @@
    ********************************************************/
   
-  cout << "<" << name << "> Instanciation of registerFile" << endl;
+  cout << "<" << name << "> Instanciation of registerfile" << endl;
   
   (*(registerfile->in_CLOCK))        (CLOCK);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h	(revision 15)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_generic_registerfile_Parameters_h
-#define morpheo_behavioural_generic_registerfile_Parameters_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_monolithic_Parameters_h
+#define morpheo_behavioural_generic_registerfile_registerfile_monolithic_Parameters_h
 
 /*
@@ -17,4 +17,5 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
   class Parameters : public morpheo::behavioural::Parameters
@@ -36,7 +37,8 @@
   public :        string   print      (uint32_t depth);
   public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::registerfile::Parameters & x);
+				       morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters & x);
   };
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 15)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 15)
@@ -0,0 +1,139 @@
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_monolithic_RegisterFile_Monolithic
+#define morpheo_behavioural_generic_registerfile_registerfile_monolithic_RegisterFile_Monolithic
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include "Include/Debug.h"
+#include "Include/ToString.h"
+#include <iostream>
+using namespace std;
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Types.h"
+#ifdef STATISTICS
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Statistics.h"
+#endif
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+#ifdef VHDL_TESTBENCH
+#include "Behavioural/include/Vhdl_Testbench.h"
+#endif
+
+using namespace std;
+
+namespace morpheo                    {
+namespace behavioural                {
+namespace generic                    {
+namespace registerfile               {
+namespace registerfile_monolithic    {
+
+  class RegisterFile_Monolithic 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const string     _name;
+
+  protected : const Parameters _param;
+#ifdef STATISTICS
+  private   : Statistics                     * _stat;
+    
+  private   : uint32_t                         _stat_nb_read;
+  private   : uint32_t                         _stat_nb_write;
+#endif
+
+#ifdef VHDL_TESTBENCH
+  private   : Vhdl_Testbench                 * _vhdl_testbench;
+#endif
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // Interface
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_CLOCK                      *  in_NRESET       ;
+
+    // ----- Interface Read
+  public    : SC_IN       (Tcontrol_t)     **  in_READ_VAL     ;
+  public    : SC_OUT      (Tcontrol_t)     ** out_READ_ACK     ;
+  public    : SC_IN       (Taddress_t)     **  in_READ_ADDRESS ;
+  public    : SC_OUT      (Tdata_t)        ** out_READ_DATA    ;
+
+    // ----- Interface Write
+  public    : SC_IN       (Tcontrol_t)     **  in_WRITE_VAL    ;
+  public    : SC_OUT      (Tcontrol_t)     ** out_WRITE_ACK    ;
+  public    : SC_IN       (Taddress_t)     **  in_WRITE_ADDRESS;
+  public    : SC_IN       (Tdata_t)        **  in_WRITE_DATA   ;
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+  private   : SC_REGISTER (Tdata_t)        ** reg_DATA         ;
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#endif
+
+    // -----[ methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (RegisterFile_Monolithic);
+#endif					       
+
+  public  :          RegisterFile_Monolithic   (
+#ifdef SYSTEMC
+						sc_module_name                              name,
+#else					       
+						string                                      name,
+#endif					       
+#ifdef STATISTICS
+						morpheo::behavioural::Parameters_Statistics param_statistics,
+#endif
+					        Parameters                                  param );
+					       
+  public  :          RegisterFile_Monolithic   (Parameters param );
+  public  :          ~RegisterFile_Monolithic  (void);
+					       
+#ifdef SYSTEMC				       
+  private : void     allocation                (void);
+  private : void     deallocation              (void);
+					       
+  public  : void     transition                (void);
+//public  : void     genMoore                  (void) {/* empty */};
+  public  : void     genMealy_read             (void);
+#endif					       
+
+#ifdef STATISTICS
+  public  : string  statistics                 (uint32_t depth);
+#endif					       
+#if VHDL				       
+  private : void     vhdl                      (void);
+  private : void     vhdl_port                 (Vhdl & vhdl);
+  private : void     vhdl_type                 (Vhdl & vhdl);
+  private : void     vhdl_signal               (Vhdl & vhdl);
+  private : void     vhdl_body                 (Vhdl & vhdl);
+#endif					       
+					       
+#ifdef VHDL_TESTBENCH			       
+  private : void     vhdl_testbench            (Vhdl_Testbench & vhdl_testbench);
+  private : void     vhdl_testbench_port       (Vhdl_Testbench & vhdl_testbench);
+  private : void     vhdl_testbench_transition (Vhdl_Testbench & vhdl_testbench);
+#endif
+
+  };
+
+}; // end namespace registerfile_monolithic
+}; // end namespace registerfile 
+}; // end namespace generic
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Statistics.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Statistics.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Statistics.h	(revision 15)
@@ -1,5 +1,5 @@
 #ifdef STATISTICS
-#ifndef morpheo_behavioural_generic_registerfile_Statistics_h
-#define morpheo_behavioural_generic_registerfile_Statistics_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_monolithic_Statistics_h
+#define morpheo_behavioural_generic_registerfile_registerfile_monolithic_Statistics_h
 
 /*
@@ -14,5 +14,5 @@
 #include "Behavioural/include/Parameters_Statistics.h"
 #include "Behavioural/Generic/Group/include/Statistics.h"
-#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
 
 using namespace morpheo::behavioural::generic::group;
@@ -22,4 +22,5 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
   class Statistics : public morpheo::behavioural::Statistics
@@ -48,4 +49,5 @@
   };
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Types.h	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Types.h	(revision 15)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_generic_registerfile_Type_h
-#define morpheo_behavioural_generic_registerfile_Type_h
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_monolithic_Type_h
+#define morpheo_behavioural_generic_registerfile_registerfile_monolithic_Type_h
 
 /*
@@ -15,8 +15,10 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
   typedef uint32_t Taddress_t;
   typedef uint32_t Tdata_t;
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters.cpp	(revision 15)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
 
 namespace morpheo                    {
@@ -12,4 +12,5 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
   Parameters::Parameters (uint32_t nb_port_read ,
@@ -38,4 +39,5 @@
   { };
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_msg_error.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_msg_error.cpp	(revision 15)
@@ -7,6 +7,6 @@
 
 #include <stdint.h>
-#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
-#include "Behavioural/Generic/RegisterFile/include/Types.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Types.h"
 #include <sstream>
 using namespace std;
@@ -16,4 +16,5 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
   string Parameters::msg_error(void)
@@ -45,4 +46,5 @@
   };
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_print.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/Parameters_print.cpp	(revision 15)
@@ -7,5 +7,5 @@
 
 #include <stdint.h>
-#include "Behavioural/Generic/RegisterFile/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Parameters.h"
 #include <sstream>
 using namespace std;
@@ -15,4 +15,5 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
   string Parameters::print (uint32_t depth)
@@ -20,10 +21,10 @@
     string tab = string(depth,'\t');
     ostringstream msg;
-    msg << tab << "<registerfile>" << endl
+    msg << tab << "<registerfile_monolithic>" << endl
 	<< tab << "\t<nb_port_read  value=\"" << _nb_port_read  << "\" />" << endl
 	<< tab << "\t<nb_port_write value=\"" << _nb_port_write << "\" />" << endl
 	<< tab << "\t<nb_word       value=\"" << _nb_word       << "\" />" << endl
 	<< tab << "\t<size_word     value=\"" << _size_word     << "\" />" << endl
-	<< tab << "</registerfile>" << endl;
+	<< tab << "</registerfile_monolithic>" << endl;
     
     return msg.str();
@@ -31,5 +32,5 @@
 
   ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::registerfile::Parameters & x)
+		       morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters & x)
   {
     output_stream << x.print(0);
@@ -38,4 +39,5 @@
   };
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic.cpp	(revision 11)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic.cpp	(revision 15)
@@ -6,5 +6,5 @@
  */
 
-#include "Behavioural/Generic/RegisterFile/include/RegisterFile.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
 
 namespace morpheo                    {
@@ -12,16 +12,18 @@
 namespace generic                    {
 namespace registerfile               {
+namespace registerfile_monolithic    {
 
+  RegisterFile_Monolithic::RegisterFile_Monolithic (
 #ifdef SYSTEMC
-  RegisterFile::RegisterFile (sc_module_name name,
+						    sc_module_name name,
 #else
-  RegisterFile::RegisterFile (string name        ,
+						    string name        ,
 #endif
 #ifdef STATISTICS
-			      morpheo::behavioural::Parameters_Statistics             param_statistics,
+						    morpheo::behavioural::Parameters_Statistics             param_statistics,
 #endif
-			      morpheo::behavioural::generic::registerfile::Parameters param ):
-			      _name   (name)
-			      ,_param (param)
+						    morpheo::behavioural::generic::registerfile::registerfile_monolithic::Parameters param ):
+    _name   (name),
+    _param (param)
   {
 #ifdef STATISTICS
@@ -72,5 +74,5 @@
   };
   
-  RegisterFile::~RegisterFile (void)
+  RegisterFile_Monolithic::~RegisterFile_Monolithic (void)
   {
 #ifdef SYSTEMC
@@ -90,4 +92,5 @@
   };
 
+}; // end namespace registerfile_monolithic
 }; // end namespace registerfile 
 }; // end namespace generic
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_allocation.cpp	(revision 15)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_allocation.cpp	(revision 15)
@@ -0,0 +1,83 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
+
+namespace morpheo                    {
+namespace behavioural                {
+namespace generic                    {
+namespace registerfile               {
+namespace registerfile_monolithic    {
+
+  void RegisterFile_Monolithic::allocation (void)
+  {
+    in_CLOCK  = new SC_CLOCK           ("in_CLOCK");
+    in_NRESET = new SC_IN (Tcontrol_t) ("in_NRESET");
+
+    // ----- Interface Read
+     in_READ_VAL         = new SC_IN (Tcontrol_t) * [_param._nb_port_read];
+    out_READ_ACK         = new SC_OUT(Tcontrol_t) * [_param._nb_port_read];
+     in_READ_ADDRESS     = new SC_IN (Taddress_t) * [_param._nb_port_read];
+    out_READ_DATA        = new SC_OUT(Tdata_t   ) * [_param._nb_port_read];
+
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      {
+	string rename;
+
+	rename = "in_READ_VAL["     + toString(i) + "]";
+	in_READ_VAL     [i]  = new SC_IN (Tcontrol_t) (rename.c_str());
+
+	rename = "out_READ_ACK["     + toString(i) + "]";
+	out_READ_ACK    [i]  = new SC_OUT(Tcontrol_t) (rename.c_str());
+
+	rename = "in_READ_ADDRESS[" + toString(i) + "]";
+	in_READ_ADDRESS [i]  = new SC_IN (Taddress_t) (rename.c_str());
+
+	rename = "out_READ_DATA["    + toString(i) + "]";
+	out_READ_DATA   [i]  = new SC_OUT(Tdata_t)    (rename.c_str());
+      }
+
+    // ----- Interface Write
+     in_WRITE_VAL        = new SC_IN (Tcontrol_t) * [_param._nb_port_write];
+    out_WRITE_ACK        = new SC_OUT(Tcontrol_t) * [_param._nb_port_write];
+     in_WRITE_ADDRESS    = new SC_IN (Taddress_t) * [_param._nb_port_write];
+     in_WRITE_DATA       = new SC_IN (Tdata_t   ) * [_param._nb_port_write];
+    
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	string rename;
+
+	rename = "in_WRITE_VAL["  + toString(i) + "]";
+	in_WRITE_VAL     [i]  = new SC_IN (Tcontrol_t) (rename.c_str());
+
+	rename = "out_WRITE_VAL["  + toString(i) + "]";
+	out_WRITE_ACK    [i]  = new SC_OUT(Tcontrol_t) (rename.c_str());
+
+	rename = "in_WRITE_ADDRESS[" + toString(i) + "]";
+	in_WRITE_ADDRESS [i]  = new SC_IN (Taddress_t) (rename.c_str());
+
+	rename = "in_WRITE_DATA["    + toString(i) + "]";
+	in_WRITE_DATA    [i]  = new SC_IN (Tdata_t)    (rename.c_str());
+      }
+
+    // ----- Register
+    reg_DATA = new SC_REGISTER (Tdata_t) * [_param._nb_word];
+    
+    for (uint32_t i=0; i<_param._nb_word; i++)
+      {
+	string rename = "reg_DATA["  + toString(i) + "]";
+	reg_DATA [i]  = new SC_REGISTER (Tdata_t) (rename.c_str());
+      }    
+  };
+
+}; // end namespace registerfile_monolithic
+}; // end namespace registerfile 
+}; // end namespace generic
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_deallocation.cpp	(revision 15)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_deallocation.cpp	(revision 15)
@@ -0,0 +1,63 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
+
+namespace morpheo                    {
+namespace behavioural                {
+namespace generic                    {
+namespace registerfile               {
+namespace registerfile_monolithic    {
+
+  void RegisterFile_Monolithic::deallocation (void)
+  {
+    delete in_CLOCK;
+    delete in_NRESET;
+    // ----- Interface Read
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      {
+	delete  in_READ_VAL     [i];
+	delete out_READ_ACK     [i];
+	delete  in_READ_ADDRESS [i];
+	delete out_READ_DATA    [i];
+      }
+
+    delete  in_READ_VAL    ;
+    delete out_READ_ACK    ;
+    delete  in_READ_ADDRESS;
+    delete out_READ_DATA   ;
+
+    // ----- Interface Write
+    for (uint32_t i=0; i<_param._nb_port_write; i++)
+      {
+	delete  in_WRITE_VAL     [i];
+	delete out_WRITE_ACK     [i];
+	delete  in_WRITE_ADDRESS [i];
+	delete  in_WRITE_DATA    [i];
+      }
+
+    delete  in_WRITE_VAL    ;
+    delete out_WRITE_ACK    ;
+    delete  in_WRITE_ADDRESS;
+    delete  in_WRITE_DATA   ;
+
+    // ----- Register
+    for (uint32_t i=0; i<_param._nb_word; i++)
+      {
+	delete reg_DATA [i];
+      }    
+
+    delete reg_DATA;
+  };
+
+}; // end namespace registerfile_monolithic
+}; // end namespace registerfile 
+}; // end namespace generic
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_genMealy_read.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_genMealy_read.cpp	(revision 15)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_genMealy_read.cpp	(revision 15)
@@ -0,0 +1,56 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
+
+namespace morpheo                    {
+namespace behavioural                {
+namespace generic                    {
+namespace registerfile               {
+namespace registerfile_monolithic    {
+
+  void RegisterFile_Monolithic::genMealy_read (void)
+  {
+    log_printf(FUNC,Register_File,"genMealy_read","Begin");
+
+#ifdef STATISTICS
+    _stat_nb_read = 0;
+#endif    
+
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
+      {
+	// Have a write?
+ 	if ( PORT_READ(in_READ_VAL [i]) == 1)
+ 	  {
+	    Taddress_t address = PORT_READ(in_READ_ADDRESS[i]);
+	    Tdata_t    data    = REGISTER_READ(reg_DATA[address]);
+
+	    log_printf(TRACE,Register_File,"genMealy_read","[%d] -> %.8x",static_cast<uint32_t>(address),static_cast<uint32_t>(data));
+
+#ifdef STATISTICS
+	    _stat_nb_read ++;
+#endif    
+	    // Write in registerFile
+	    PORT_WRITE(out_READ_DATA[i],data);
+ 	  }
+	else
+	  {
+	    //log_printf(TRACE,Register_File,"genMealy_read","Read  [%d] : No   transaction",i);
+	    PORT_WRITE(out_READ_DATA[i],0);
+	  }
+      }
+    log_printf(FUNC,Register_File,"genMealy_read","End");
+	
+  };
+
+}; // end namespace registerfile_monolithic
+}; // end namespace registerfile 
+}; // end namespace generic
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_statistics.cpp	(revision 15)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_statistics.cpp	(revision 15)
@@ -0,0 +1,27 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h"
+
+namespace morpheo                    {
+namespace behavioural                {
+namespace generic                    {
+namespace registerfile               {
+namespace registerfile_monolithic    {
+
+  string RegisterFile_Monolithic::statistics (uint32_t depth)
+  {
+    return _stat->print(depth);
+  };
+
+}; // end namespace registerfile_monolithic
+}; // end namespace registerfile 
+}; // end namespace generic
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
